<template>
  <div class="px-3 pt-3">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0 text-dark">Dashboard</h1>
          </div>
          <!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item">
                <a href="#">Home</a>
              </li>
              <li class="breadcrumb-item active">Dashboard v1</li>
            </ol>
          </div>
          <!-- /.col -->
        </div>
        <!-- /.row -->
      </div>
      <!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <section class="content">
      <div class="container-fluid">
        <!-- Small boxes (Stat box) -->
        <div class="row">
          <div class="col-lg-3 col-6">
            <!-- small box -->
            <div class="small-box bg-danger">
              <div class="inner">
                <h3>{{ filteredTrainers.length }}</h3>

                <p>Trainers</p>
              </div>
              <div class="icon">
                <i class="fa fa-running"></i>
              </div>
              <a href="#" class="small-box-footer py-2">
                <v-btn
                  small
                  class="mx-1"
                  :class="trainersSelected == 'ALL' ? 'v-btn--active' : ''"
                  @click="setTrainersStatus('ALL')"
                >
                  All
                </v-btn>
                <v-btn
                  small
                  class="mx-1"
                  :class="trainersSelected == 'ACTIVE' ? 'v-btn--active' : ''"
                  @click="setTrainersStatus('ACTIVE')"
                >
                  Active
                </v-btn>
                <v-btn
                  small
                  class="mx-1"
                  :class="trainersSelected == 'INACTIVE' ? 'v-btn--active' : ''"
                  @click="setTrainersStatus('INACTIVE')"
                >
                  Inactive
                </v-btn>
              </a>
            </div>
          </div>

          <!-- col -->
          <div class="col-lg-3 col-6">
            <!-- small box -->
            <div class="small-box bg-warning">
              <div class="inner">
                <h3>{{ filteredClients.length }}</h3>

                <p>clients</p>
              </div>
              <div class="icon">
                <i class="fa fa-users"></i>
              </div>
              <a href="#" class="small-box-footer py-2">
                <v-btn
                  small
                  class="mx-1"
                  :class="clientsSelected == 'ALL' ? 'v-btn--active' : ''"
                  @click="setClientsStatus('ALL')"
                >
                  All
                </v-btn>
                <v-btn
                  small
                  class="mx-1"
                  :class="clientsSelected == 'ACTIVE' ? 'v-btn--active' : ''"
                  @click="setClientsStatus('ACTIVE')"
                >
                  Active
                </v-btn>
                <v-btn
                  small
                  class="mx-1"
                  :class="clientsSelected == 'INACTIVE' ? 'v-btn--active' : ''"
                  @click="setClientsStatus('INACTIVE')"
                >
                  Inactive
                </v-btn>
              </a>
            </div>
          </div>

          <div class="col-lg-3 col-6">
            <!-- small box -->
            <div class="small-box bg-primary">
              <div class="inner">
                <h3>{{ filteredVenues.length }}</h3>

                <p>Venues</p>
              </div>
              <div class="icon">
                <i class="fa fa-home"></i>
              </div>
              <a href="#" class="small-box-footer py-2">
                <v-btn
                  small
                  class="mx-1"
                  :class="venuesSelected == 'ALL' ? 'v-btn--active' : ''"
                  @click="setVenuesStatus('ALL')"
                >
                  All
                </v-btn>
                <v-btn
                  small
                  class="mx-1"
                  :class="venuesSelected == 'ACTIVE' ? 'v-btn--active' : ''"
                  @click="setVenuesStatus('ACTIVE')"
                >
                  Active
                </v-btn>
                <v-btn
                  small
                  class="mx-1"
                  :class="venuesSelected == 'INACTIVE' ? 'v-btn--active' : ''"
                  @click="setVenuesStatus('INACTIVE')"
                >
                  Inactive
                </v-btn>
              </a>
            </div>
          </div>

          <div class="col-lg-3 col-6">
            <!-- small box -->
            <div class="small-box bg-secondary">
              <div class="inner">
                <h3>{{ recentTrainers.length }}</h3>

                <p>Recently Registered Trainers</p>
              </div>
              <div class="icon">
                <i class="fa fa-running"></i>
              </div>
            </div>
          </div>

          <div class="col-lg-3 col-6">
            <!-- small box -->
            <div class="small-box bg-info">
              <div class="inner">
                <h3>{{ recentClients.length }}</h3>

                <p>Recently Registered Clients</p>
              </div>
              <div class="icon">
                <i class="fa fa-user-check"></i>
              </div>
            </div>
          </div>
          <!-- ./col -->
        </div>
        <div class="d-flex justify-content-center">
          <div class="col-sm-12 col-lg-8">
            <v-card>
              <v-card-title> Incoming trainer requests </v-card-title>
              <v-simple-table class="p-3">
                <template v-slot:default>
                  <thead>
                    <tr>
                      <th class="text-left">First name</th>
                      <th class="text-left">Last name</th>
                      <th class="text-left">Phone</th>
                      <th class="text-left">Accept/Decline</th>
                    </tr>
                  </thead>
                  <tbody>
                    <tr
                      v-for="trainer in pendingTrainers"
                      :key="trainer.trainerId"
                    >
                      <td>{{ trainer.firstName }}</td>
                      <td>{{ trainer.lastName }}</td>
                      <td>{{ trainer.phone }}</td>
                      <td>
                        <v-btn color="primary" @click="acceptTrainer(trainer)"
                          >Accept</v-btn
                        ><v-btn
                          class="ml-2"
                          color="error"
                          @click="declineTrainer(trainer)"
                          >Decline</v-btn
                        >
                      </td>
                    </tr>
                  </tbody>
                </template>
              </v-simple-table>
            </v-card>
          </div>
        </div>
        <!-- /.row -->
        <div class="d-flex">
          <ul class="nav nav-pills col">
            <li class="nav-item mx-1">
              <v-btn
                class="nav-link"
                :class="selectedTab === 'WEEK' ? 'v-btn--active' : ''"
                @click="showWeek"
              >
                Last Week
              </v-btn>
            </li>

            <li class="nav-item mx-1">
              <v-btn
                class="nav-link"
                :class="selectedTab === 'MONTH' ? 'v-btn--active' : ''"
                @click="showMonth"
              >
                Last Month
              </v-btn>
            </li>

            <li class="nav-item mx-1">
              <v-btn
                class="nav-link"
                :class="selectedTab === 'YEAR' ? 'v-btn--active' : ''"
                @click="showYear"
              >
                Last Year
              </v-btn>
            </li>

            <li class="nav-item mx-1">
              <v-btn
                class="nav-link"
                :class="selectedTab === '5YEAR' ? 'v-btn--active' : ''"
                @click="show5Year"
              >
                Last 5 Years
              </v-btn>
            </li>

            <li class="nav-item mx-1">
              <v-btn
                class="nav-link"
                :class="selectedTab === 'ALL' ? 'v-btn--active' : ''"
                @click="showAll"
              >
                All Time
              </v-btn>
            </li>
          </ul>
        </div>
        <div class="row">
          <div class="col-12">
            <v-card>
              <v-card-title>
                <div>Sales</div>
                <div class="ml-auto">
                  Total:
                  {{
                    chartData.datasets[0].totalSales
                      ? chartData.datasets[0].totalSales + "kr"
                      : ""
                  }}
                </div>
              </v-card-title>
              <v-card-text>
                <line-chart
                  :chart-data="chartData"
                  :options="{ responisve: true, maintainAspectRatio: false }"
                >
                </line-chart>
              </v-card-text>
            </v-card>
          </div>
        </div>
      </div>
      <!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
</template>

<script>
import LineChart from "../../plugins/linechart";
import invoiceController from "../../controllers/invoice.controller";
import moment from "moment";
import swal from "sweetalert2";
import userController from "../../controllers/user.controller";
import trainerController from "../../controllers/trainer.controller";
import venue from "../../controllers/venue.controller";
export default {
  components: { LineChart },
  name: "AdminDashboard",
  props: ["user"],
  computed: {
    recentClients() {
      let lastWeek = moment().subtract(1, "week");
      return this.clients.filter((client) => {
        return moment(client.createdAt).isAfter(lastWeek);
      });
    },
    recentTrainers() {
      let lastWeek = moment().subtract(1, "week");
      return this.trainers.filter((trainer) => {
        return moment(trainer.createdAt).isAfter(lastWeek);
      });
    },
    filteredTrainers() {
      return this.trainers.filter((trainer) => {
        if (this.trainersSelected === "ACTIVE") {
          return trainer.isActive;
        } else if (this.trainersSelected === "INACTIVE") {
          return !trainer.isActive;
        } else {
          return true;
        }
      });
    },
    filteredClients() {
      return this.clients.filter((client) => {
        if (this.clientsSelected === "ACTIVE") {
          return client.isActive;
        } else if (this.clientsSelected === "INACTIVE") {
          return !client.isActive;
        } else {
          return true;
        }
      });
    },
    filteredVenues() {
      return this.venues.filter((venue) => {
        if (this.venuesSelected === "ACTIVE") {
          return venue.isActive;
        } else if (this.venuesSelected === "INACTIVE") {
          return !venue.isActive;
        } else {
          return true;
        }
      });
    },
    pendingTrainers() {
      return this.trainers.filter(
        (trainer) => trainer.activationStatus === "Pending"
      );
    },
  },
  data() {
    return {
      selectedTab: "ALL",
      venuesSelected: "ALL",
      clientsSelected: "ALL",
      trainersSelected: "ALL",
      invoices: [],
      clients: [],
      trainers: [],
      venues: [],
      chartData: {
        datasets: [{ label: "Loading" }],
      },
    };
  },
  methods: {
    async acceptTrainer(trainer) {
      let yes = await swal.fire({
        title: "Are you sure?",
        showConfirmButton: true,
        showCancelButton: true,
        confirmButtonText: "Yes",
        cancelButtonText: "No",
      });
      if (!yes.value) {
        return;
      }
      try {
        const res = await trainerController.updateTrainerStatus(
          trainer.trainerId,
          "Accepted"
        );
        const res2 = await trainerController.enableTrainer(trainer.trainerId);
        if (res.status == "204" && res2.status == "204") {
          swal.fire("success", "", "success");
          let index = this.trainers.indexOf(trainer);
          this.trainers[index].activationStatus = "Accepted";
          this.trainers[index].isActive = true;
        } else {
          console.log(res, res2);
          swal.fire("Oops... Could not update the trainer", "", "error");
        }
      } catch (e) {
        console.log(e);
        swal.fire(
          "Oops... Could not update the trainer",
          "Check your connection",
          "error"
        );
      }
    },
    async declineTrainer(trainer) {
      let yes = await swal.fire({
        title: "Are you sure?",
        showConfirmButton: true,
        showCancelButton: true,
        confirmButtonText: "Yes",
        cancelButtonText: "No",
      });
      if (!yes.value) {
        return;
      }
      try {
        const res = await trainerController.updateTrainerStatus(
          trainer.trainerId,
          "Declined"
        );
        if (res.status == "204") {
          swal.fire("success", "", "success");
          let index = this.trainers.indexOf(trainer);
          this.trainers[index].activationStatus = "Declined";
        } else {
          swal.fire("Oops... Could not update the trainer", "", "error");
        }
      } catch (e) {
        swal.fire(
          "Oops... Could not update the trainer",
          "Check your connection",
          "error"
        );
      }
    },
    setVenuesStatus(status) {
      this.venuesSelected = status;
    },
    setClientsStatus(status) {
      this.clientsSelected = status;
    },
    setTrainersStatus(status) {
      this.trainersSelected = status;
    },
    showWeek() {
      this.selectedTab = "WEEK";
      this.computeGraphData(moment().subtract(1, "week"));
    },
    showMonth() {
      this.selectedTab = "MONTH";
      this.computeGraphData(moment().subtract(1, "month"));
    },
    showYear() {
      this.selectedTab = "YEAR";
      this.computeGraphData(moment().subtract(1, "year"));
    },
    show5Year() {
      this.selectedTab = "5YEAR";
      this.computeGraphData(moment().subtract(5, "years"));
    },
    showAll() {
      this.selectedTab = "ALL";
      this.computeGraphData();
    },
    computeGraphData(cutoff) {
      let label = [];
      let data = [];
      let allData = {};
      let totalSales = 0;

      for (const invoice of this.invoices) {
        const date = moment(invoice.issueDate);
        let totalValue = 0;

        invoice.invoiceLines.forEach((line) => {
          totalValue += line.quantity * line.price;
        });

        if (cutoff && date.isAfter(cutoff)) {
          label.push(date.toISOString().split("T")[0]);
          totalSales += totalValue;
          data.push(totalValue);
        } else if (!cutoff) {
          data.push(totalValue);
          totalSales += totalValue;
          label.push(date.toISOString().split("T")[0]);
        }
      }

      allData.datasets = [];
      allData.labels = label;
      allData.datasets.push({
        totalSales: totalSales,
        label: "sales in kr",
        fill: false,
        data: data,
        backgroundColor: "#0275d8 ",
        borderColor: "#0275d8 ",
      });

      this.chartData = allData;
    },
    async getAllInvoices() {
      try {
        const res = await invoiceController.getInvoicesDetail();
        if (res.status == '200') {
          this.invoices = res.data;
        }

        this.computeGraphData();
      } catch (e) {
        console.log(e);
        swal.fire({
          icon: "error",
          title: "Something went wrong...",
        });
      }
    },
    async getAllClients() {
      try {
        const trainers = await trainerController.getTrainers();
        if (trainers) {
          this.trainers = trainers;
        }
      } catch (e) {
        swal.fire({
          icon: "error",
          title: "Could not retrieve trainers",
        });
      }
    },
    async getAllTrainers() {
      try {
        const res = await userController.getAllClients();
        if (res.status === 200) {
          this.clients = res.data;
        } else {
          swal.fire({
            icon: "error",
            title: "Could not retrieve clients",
          });
        }
      } catch (e) {
        swal.fire({
          icon: "error",
          title: "Could not retrieve clients",
        });
      }
    },
    async getAllVenues() {
      try {
        const res = await venue.getVenues();
        if (res.status === 200) {
          this.venues = res.data;
        } else {
          swal.fire({
            icon: "error",
            title: "Could not retrieve clients",
          });
        }
      } catch (e) {
        swal.fire({
          icon: "error",
          title: "Could not retrieve clients",
        });
      }
    },
  },
  async mounted() {
    await this.getAllClients();
    await this.getAllTrainers();
    await this.getAllVenues();
    await this.getAllInvoices();
  },
};
</script>

<style>
.test {
  color: white;
}
</style>
